## freerdp3 3.22.0+dfsg

=== CMakeLists.txt ===
# FreeRDP: A Remote Desktop Protocol Implementation
# FreeRDP cmake build script
#
# Copyright 2011 O.S. Systems Software Ltda.
# Copyright 2011 Otavio Salvador <otavio@ossystems.com.br>
# Copyright 2011 Marc-Andre Moreau <marcandre.moreau@gmail.com>
# Copyright 2012 HP Development Company, LLC
#
# Licensed under the Apache License, Version 2.0 (the "License");
# you may not use this file except in compliance with the License.
# You may obtain a copy of the License at
#
#     http://www.apache.org/licenses/LICENSE-2.0
#
# Unless required by applicable law or agreed to in writing, software
# distributed under the License is distributed on an "AS IS" BASIS,
# WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
# See the License for the specific language governing permissions and
# limitations under the License.

cmake_minimum_required(VERSION 3.13)

if(POLICY CMP0091)
  cmake_policy(SET CMP0091 NEW)
endif()
project(FreeRDP LANGUAGES C)

add_custom_target(fuzzers COMMENT "Build fuzzers")

if(NOT PROJECT_SOURCE_DIR STREQUAL PROJECT_BINARY_DIR)
  # Git auto-ignore out-of-source build directory
  file(GENERATE OUTPUT .gitignore CONTENT "*")
endif()

if(NOT DEFINED VENDOR)
  set(VENDOR "FreeRDP" CACHE STRING "FreeRDP package vendor")
endif()

if(NOT DEFINED PRODUCT)
  set(PRODUCT "FreeRDP" CACHE STRING "FreeRDP package name")
endif()

if(NOT DEFINED PROJECT_URL)
  set(PROJECT_URL "https://freerdp.com" CACHE STRING "FreeRDP package url")
endif()

if(NOT DEFINED FREERDP_VENDOR)
  set(FREERDP_VENDOR 1)
endif()

if(NOT WIN32 AND NOT ANDROID)
  if(APPLE)
    set(OPT_DEFAULT_VAL OFF)
  else()
    set(OPT_DEFAULT_VAL ON)
  endif()
  option(WITH_X11 "build X11 client/server" ${OPT_DEFAULT_VAL})
endif()

# Enable coverity related pragma definitions
if(COVERITY_BUILD)
  add_compile_definitions(COVERITY_BUILD)
endif()

# Include our extra modules
list(APPEND CMAKE_MODULE_PATH ${PROJECT_SOURCE_DIR}/cmake/)

include(ProjectCStandard)
include(PkgConfigHelpers)

# Check for cmake compatibility (enable/disable features)
include(CheckCmakeCompat)

# Include cmake modules
if(WITH_CLANG_FORMAT)
  include(ClangFormat)
endif()

include(CompilerFlags)
include(CheckIncludeFiles)
include(CheckLibraryExists)
include(CheckSymbolExists)
include(CheckStructHasMember)
include(TestBigEndian)
include(CompilerDetect)

include(FindFeature)
include(ShowCMakeVars)
include(ConfigOptions)
include(FeatureSummary)
include(CheckCCompilerFlag)
include(CMakePackageConfigHelpers)
include(InstallFreeRDPMan)
include(GetGitRevisionDescription)
include(SetFreeRDPCMakeInstallDir)
include(Doxygen)
include(GetSysconfDir)

# Soname versioning
set(BUILD_NUMBER 0)
if($ENV{BUILD_NUMBER})
  set(BUILD_NUMBER $ENV{BUILD_NUMBER})
endif()

include(GetProjectVersion)
get_project_version(
  FREERDP_VERSION_MAJOR FREERDP_VERSION_MINOR FREERDP_VERSION_REVISION FREERDP_VERSION_SUFFIX GIT_REVISION
)

set(FREERDP_API_VERSION "${FREERDP_VERSION_MAJOR}")
set(FREERDP_VERSION "${FREERDP_VERSION_MAJOR}.${FREERDP_VERSION_MINOR}.${FREERDP_VERSION_REVISION}")
if(FREERDP_VERSION_SUFFIX)
  set(FREERDP_VERSION_FULL "${FREERDP_VERSION}-${FREERDP_VERSION_SUFFIX}")
else()
  set(FREERDP_VERSION_FULL "${FREERDP_VERSION}")
endif()
message("FREERDP_VERSION=${FREERDP_VERSION_FULL}")

message(STATUS "Git Revision ${GIT_REVISION}")

# MSVC compatibility with system headers
add_compile_definitions(NONAMELESSUNION)

# Make the detected version available as default version for all subprojects
set(FREERDP_DEFAULT_PROJECT_VERSION ${FREERDP_VERSION} CACHE STRING INTERNAL)

set(FREERDP_MAJOR_DIR "freerdp${FREERDP_VERSION_MAJOR}")
set(FREERDP_INCLUDE_DIR "include/${FREERDP_MAJOR_DIR}/")

option(WITH_SMARTCARD_EMULATE "Emulate smartcards instead of redirecting readers" ON)
if(WITH_SMARTCARD_EMULATE)
  add_compile_definitions(WITH_SMARTCARD_EMULATE)
  find_package(ZLIB REQUIRED)
endif()

option(WITH_FREERDP_DEPRECATED "Build FreeRDP deprecated symbols" OFF)
if(WITH_FREERDP_DEPRECATED)
  add_compile_definitions(WITH_FREERDP_DEPRECATED)
endif()

option(WITHOUT_FREERDP_3x_DEPRECATED "Build FreeRDP 3x deprecated symbols" OFF)
if(WITH_FREERDP_3x_DEPRECATED)
  message(WARNING "WITH_FREERDP_3x_DEPRECATED has been replaced with WITHOUT_FREERDP_3x_DEPRECATED")
  set(WITHOUT_FREERDP_3x_DEPRECATED OFF)
endif()

option(WITH_FREERDP_DEPRECATED_COMMANDLINE "Build FreeRDP deprecated command line options" OFF)
if(WITH_FREERDP_DEPRECATED_COMMANDLINE)
  add_compile_definitions(WITH_FREERDP_DEPRECATED_COMMANDLINE)
endif()

# Make paths absolute
if(CMAKE_INSTALL_PREFIX)
  get_filename_component(CMAKE_INSTALL_PREFIX "${CMAKE_INSTALL_PREFIX}" ABSOLUTE)
endif()
if(FREERDP_EXTERNAL_PATH)
  get_filename_component(FREERDP_EXTERNAL_PATH "${FREERDP_EXTERNAL_PATH}" ABSOLUTE)
endif()

# Allow to search the host machine for git/ccache
if(CMAKE_CROSSCOMPILING)
  set(CMAKE_FIND_ROOT_PATH_MODE_PROGRAM BOTH)
endif(CMAKE_CROSSCOMPILING)

find_program(CCACHE ccache)
if(CCACHE AND WITH_CCACHE)
  if(NOT DEFINED CMAKE_C_COMPILER_LAUNCHER)
    set(CMAKE_C_COMPILER_LAUNCHER ${CCACHE})
  endif(NOT DEFINED CMAKE_C_COMPILER_LAUNCHER)
endif(CCACHE AND WITH_CCACHE)

if(CMAKE_CROSSCOMPILING)
  set(CMAKE_FIND_ROOT_PATH_MODE_PROGRAM ONLY)
endif(CMAKE_CROSSCOMPILING)
# /Allow to search the host machine for git/ccache

# Turn on solution folders (2.8.4+)
set_property(GLOBAL PROPERTY USE_FOLDERS ON)

option(CTEST_OUTPUT_ON_FAILURE ON "show verbose output on CTest failures")
if(BUILD_TESTING_INTERNAL)
  set(EXPORT_ALL_SYMBOLS ON CACHE BOOL "testing default" FORCE)
  add_compile_definitions(BUILD_TESTING_INTERNAL)
elseif(BUILD_TESTING)
  set(EXPORT_ALL_SYMBOLS OFF CACHE BOOL "testing default" FORCE)
endif()

include(ExportAllSymbols)

set(THREAD_PREFER_PTHREAD_FLAG TRUE)

if(NOT IOS)
  find_package(Threads REQUIRED)
endif()

if(WIN32)
  add_compile_definitions(UNICODE _UNICODE)
  add_compile_definitions(_CRT_SECURE_NO_WARNINGS)
  add_compile_definitions(WIN32_LEAN_AND_MEAN)
  add_compile_definitions(_WINSOCK_DEPRECATED_NO_WARNINGS)

  set(CMAKE_DL_LIBS "")
  set(CMAKE_USE_RELATIVE_PATH ON)
  string(TIMESTAMP RC_VERSION_YEAR "%Y")

  if(NOT DEFINED CMAKE_WINDOWS_VERSION)
    set(CMAKE_WINDOWS_VERSION "WIN7")
  endif()

  if(CMAKE_WINDOWS_VERSION STREQUAL "WINXP")
    add_compile_definitions(WINVER=0x0501 _WIN32_WINNT=0x0501)
  elseif(CMAKE_WINDOWS_VERSION STREQUAL "WIN7")
    add_compile_definitions(WINVER=0x0601 _WIN32_WINNT=0x0601)
  elseif(CMAKE_WINDOWS_VERSION STREQUAL "WIN8")
    add_compile_definitions(WINVER=0x0602 _WIN32_WINNT=0x0602)
  elseif(CMAKE_WINDOWS_VERSION STREQUAL "WIN10")
    add_compile_definitions(WINVER=0x0A00 _WIN32_WINNT=0x0A00)
  endif()

  # Set product and vendor for dll and exe version information.
  set(RC_VERSION_VENDOR ${VENDOR})
  set(RC_VERSION_PRODUCT ${PRODUCT})
  set(RC_VERSION_PATCH ${BUILD_NUMBER})
  set(RC_VERSION_DESCRIPTION
      "${FREERDP_VERSION_FULL} ${GIT_REVISION} ${CMAKE_WINDOWS_VERSION} ${CMAKE_SYSTEM_PROCESSOR}"
  )

  if(FREERDP_EXTERNAL_SSL_PATH)
    set(OPENSSL_ROOT_DIR ${FREERDP_EXTERNAL_SSL_PATH})
  endif()
endif()

add_compile_definitions(FREERDP_EXPORTS)

# Mac OS X
if(APPLE)
  if(IOS)
    if(NOT FREERDP_IOS_EXTERNAL_SSL_PATH)
      message(
        STATUS
          "FREERDP_IOS_EXTERNAL_SSL_PATH not set! Required if openssl is not found in the iOS SDK (which usually isn't"
      )
    endif()
    set(CMAKE_FIND_ROOT_PATH ${CMAKE_FIND_ROOT_PATH} ${FREERDP_IOS_EXTERNAL_SSL_PATH})
    set_property(GLOBAL PROPERTY XCODE_ATTRIBUTE_SKIP_INSTALL YES)
  endif(IOS)

  # Temporarily disabled, causes the cmake script to be reexecuted, causing the compilation to fail.
  # Workaround: specify the parameter in the command-line
  #	if(WITH_CLANG)
  #		set(CMAKE_C_COMPILER "clang")
  #	endif()

  if(WITH_VERBOSE)
    set(CMAKE_C_FLAGS "${CMAKE_C_FLAGS} -v")
  endif()
endif(APPLE)

# Android
if(ANDROID)
  set_property(GLOBAL PROPERTY FIND_LIBRARY_USE_LIB64_PATHS ${ANDROID_LIBRARY_USE_LIB64_PATHS})

  if(ANDROID_ABI STREQUAL arm64-v8a)
    include(CheckCCompilerFlag)
    check_c_compiler_flag("-mfloat-abi=softfp" ABI_SOFTFP_SUPPORTED)

    if(ABI_SOFTFP_SUPPORTED)
      # https://github.com/android/ndk/issues/910
      set(CMAKE_C_FLAGS "${CMAKE_C_FLAGS} -mfloat-abi=softfp")
    endif()
  endif()

  add_compile_definitions("$<$<CONFIG:Debug>:NDK_DEBUG=1>")

  # NOTE: Manually add -gdwarf-3, as newer toolchains default to -gdwarf-4,
  #       which is not supported by the gdbserver binary shipped with
  #       the android NDK (tested with r9b)
  add_compile_options("$<$<CONFIG:Debug>:-gdwarf-3>")
  add_link_options(-llog)

  # CMAKE_PREFIX_PATH detection is broken in most Android toolchain files
  # Append it to CMAKE_FIND_ROOT_PATH and avoid potential duplicates
  list(APPEND CMAKE_FIND_ROOT_PATH ${CMAKE_PREFIX_PATH})
  list(REMOVE_DUPLICATES CMAKE_FIND_ROOT_PATH)

  if(NOT FREERDP_EXTERNAL_PATH)
    if(IS_DIRECTORY "${CMAKE_CURRENT_SOURCE_DIR}/external/")
      set(FREERDP_EXTERNAL_PATH "${CMAKE_CURRENT_SOURCE_DIR}/external/")
    else()
      message(STATUS "FREERDP_EXTERNAL_PATH not set!")
    endif()
  endif()

  list(APPEND CMAKE_INCLUDE_PATH ${FREERDP_EXTERNAL_PATH}/${ANDROID_ABI}/include)
  list(APPEND CMAKE_LIBRARY_PATH ${FREERDP_EXTERNAL_PATH}/${ANDROID_ABI}/)
  set(CMAKE_FIND_ROOT_PATH_MODE_LIBRARY BOTH)
  set(CMAKE_FIND_ROOT_PATH_MODE_INCLUDE BOTH)

  if(WITH_GPROF)
    configure_file(
      ${PROJECT_SOURCE_DIR}/scripts/gprof_generate.sh.in ${PROJECT_BINARY_DIR}/scripts/gprof_generate.sh @ONLY
    )
  endif(WITH_GPROF)
endif()

if(UNIX OR CYGWIN)
  set(WAYLAND_FEATURE_TYPE "RECOMMENDED")
else()
  set(WAYLAND_FEATURE_TYPE "DISABLED")
endif()

if(WITH_PCSC_WINPR)
  find_package(PCSCWinPR)
endif()

set(WAYLAND_FEATURE_PURPOSE "Wayland")
set(WAYLAND_FEATURE_DESCRIPTION "Wayland client")

set(OPENSSL_FEATURE_TYPE "REQUIRED")
set(OPENSSL_FEATURE_PURPOSE "cryptography")
set(OPENSSL_FEATURE_DESCRIPTION "encryption, certificate validation, hashing functions")

set(MBEDTLS_FEATURE_TYPE "OPTIONAL")
set(MBEDTLS_FEATURE_PURPOSE "cryptography")
set(MBEDTLS_FEATURE_DESCRIPTION "[experimental] encryption, certificate validation, hashing functions")

set(PCSC_FEATURE_TYPE "RECOMMENDED")
set(PCSC_FEATURE_PURPOSE "smart card")
set(PCSC_FEATURE_DESCRIPTION "smart card device redirection")

set(OPENH264_FEATURE_TYPE "OPTIONAL")
set(OPENH264_FEATURE_PURPOSE "codec")
set(OPENH264_FEATURE_DESCRIPTION "use OpenH264 library")

set(GSM_FEATURE_TYPE "OPTIONAL")
set(GSM_FEATURE_PURPOSE "codec")
set(GSM_FEATURE_DESCRIPTION "GSM audio codec library")

set(LAME_FEATURE_TYPE "OPTIONAL")
set(LAME_FEATURE_PURPOSE "codec")
set(LAME_FEATURE_DESCRIPTION "lame MP3 audio codec library")

set(FAAD2_FEATURE_TYPE "OPTIONAL")
set(FAAD2_FEATURE_PURPOSE "codec")
set(FAAD2_FEATURE_DESCRIPTION "FAAD2 AAC audio codec library")

set(FAAC_FEATURE_TYPE "OPTIONAL")
set(FAAC_FEATURE_PURPOSE "codec")
set(FAAC_FEATURE_DESCRIPTION "FAAC AAC audio codec library")

set(SOXR_FEATURE_TYPE "OPTIONAL")
set(SOXR_FEATURE_PURPOSE "codec")
set(SOXR_FEATURE_DESCRIPTION "SOX audio resample library")

if(WIN32)
  set(WAYLAND_FEATURE_TYPE "DISABLED")
  set(PCSC_FEATURE_TYPE "DISABLED")
endif()

if(APPLE)
  set(WAYLAND_FEATURE_TYPE "DISABLED")
  if(IOS)
    set(PCSC_FEATURE_TYPE "DISABLED")
  endif()
endif()

if(ANDROID)
  set(WAYLAND_FEATURE_TYPE "DISABLED")
  set(PCSC_FEATURE_TYPE "DISABLED")
endif()

if(NOT WITHOUT_FREERDP_3x_DEPRECATED)
  find_feature(Wayland ${WAYLAND_FEATURE_TYPE} ${WAYLAND_FEATURE_PURPOSE} ${WAYLAND_FEATURE_DESCRIPTION})
endif()

option(WITH_LIBRESSL "[experimental] build with LibreSSL" OFF)
if(WITH_LIBRESSL)
  message(WARNING "-DWITH_LIBRESSL=ON: LibreSSL enabled. Expect incompatibilities.")
  message(WARNING "Only OpenSSL is tested on each release, other implementations depend on external contributions")

  find_package(LibreSSL REQUIRED)
  include_directories(SYSTEM ${LibreSSL_INCLUDE_DIRS})
  set(OPENSSL_INCLUDE_DIR ${LIBRESSL_INCLUDE_DIR})
  set(OPENSSL_LIBRARIES ${LIBRESSL_LIBRARIES})

=== include/CMakeLists.txt ===
# FreeRDP: A Remote Desktop Protocol Implementation
# include headers cmake build script
#
# Copyright 2011 O.S. Systems Software Ltda.
# Copyright 2011 Otavio Salvador <otavio@ossystems.com.br>
# Copyright 2011 Marc-Andre Moreau <marcandre.moreau@gmail.com>
#
# Licensed under the Apache License, Version 2.0 (the "License");
# you may not use this file except in compliance with the License.
# You may obtain a copy of the License at
#
#     http://www.apache.org/licenses/LICENSE-2.0
#
# Unless required by applicable law or agreed to in writing, software
# distributed under the License is distributed on an "AS IS" BASIS,
# WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
# See the License for the specific language governing permissions and
# limitations under the License.

if(NOT WITHOUT_FREERDP_3x_DEPRECATED)
  option(WITH_OPAQUE_SETTINGS "Hide rdpSettings struct definition, only allow getter/setter access" OFF)
else()
  set(WITH_OPAQUE_SETTINGS ON CACHE INTERNAL "NOT WITHOUT_FREERDP_3x_DEPRECATED")
endif()

# prepare paths for C
file(TO_NATIVE_PATH "${FREERDP_DATA_PATH}" NATIVE_FREERDP_DATA_PATH)
file(TO_NATIVE_PATH "${FREERDP_KEYMAP_PATH}" NATIVE_FREERDP_KEYMAP_PATH)
file(TO_NATIVE_PATH "${FREERDP_PLUGIN_PATH}" NATIVE_FREERDP_PLUGIN_PATH)
file(TO_NATIVE_PATH "${FREERDP_INSTALL_PREFIX}" NATIVE_FREERDP_INSTALL_PREFIX)
file(TO_NATIVE_PATH "${FREERDP_LIBRARY_PATH}" NATIVE_FREERDP_LIBRARY_PATH)
file(TO_NATIVE_PATH "${FREERDP_ADDIN_PATH}" NATIVE_FREERDP_ADDIN_PATH)
file(TO_NATIVE_PATH "${FREERDP_PROXY_PLUGINDIR}" NATIVE_FREERDP_PROXY_PLUGINDIR)

if(WIN32)
  string(REPLACE "\\" "\\\\" NATIVE_FREERDP_DATA_PATH "${NATIVE_FREERDP_DATA_PATH}")
  string(REPLACE "\\" "\\\\" NATIVE_FREERDP_KEYMAP_PATH "${NATIVE_FREERDP_KEYMAP_PATH}")
  string(REPLACE "\\" "\\\\" NATIVE_FREERDP_PLUGIN_PATH "${NATIVE_FREERDP_PLUGIN_PATH}")
  string(REPLACE "\\" "\\\\" NATIVE_FREERDP_INSTALL_PREFIX "${NATIVE_FREERDP_INSTALL_PREFIX}")
  string(REPLACE "\\" "\\\\" NATIVE_FREERDP_LIBRARY_PATH "${NATIVE_FREERDP_LIBRARY_PATH}")
  string(REPLACE "\\" "\\\\" NATIVE_FREERDP_ADDIN_PATH "${NATIVE_FREERDP_ADDIN_PATH}")
  string(REPLACE "\\" "\\\\" NATIVE_FREERDP_PROXY_PLUGINDIR "${NATIVE_FREERDP_PROXY_PLUGINDIR}")
endif()

cleaning_configure_file(${CMAKE_CURRENT_SOURCE_DIR}/config/version.h.in ${CMAKE_CURRENT_BINARY_DIR}/freerdp/version.h)
cleaning_configure_file(
  ${CMAKE_CURRENT_SOURCE_DIR}/config/build-config.h.in ${CMAKE_CURRENT_BINARY_DIR}/freerdp/build-config.h
)
cleaning_configure_file(${CMAKE_CURRENT_SOURCE_DIR}/config/config.h.in ${CMAKE_CURRENT_BINARY_DIR}/freerdp/config.h)
cleaning_configure_file(
  ${CMAKE_CURRENT_SOURCE_DIR}/config/buildflags.h.in ${CMAKE_CURRENT_BINARY_DIR}/freerdp/buildflags.h
)

file(STRINGS freerdp/settings_types_private.h SETTINGS_KEYS REGEX "ALIGN64[ \ta-zA-Z0-9]*")

set(SETTINGS_KEYS_BOOL "")
set(SETTINGS_KEYS_INT16 "")
set(SETTINGS_KEYS_UINT16 "")
set(SETTINGS_KEYS_INT32 "")
set(SETTINGS_KEYS_UINT32 "")
set(SETTINGS_KEYS_INT64 "")
set(SETTINGS_KEYS_UINT64 "")
set(SETTINGS_KEYS_STRING "")
set(SETTINGS_KEYS_POINTER "")

foreach(KEY ${SETTINGS_KEYS})
  string(STRIP "${KEY}" TRIMMED_KEY)
  string(REGEX MATCH "^SETTINGS_DEPRECATED\\(ALIGN64[ \t ]+BOOL[ \t ]+" IS_BOOL "${TRIMMED_KEY}")
  string(REGEX MATCH "^SETTINGS_DEPRECATED\\(ALIGN64[ \t ]+INT16[ \t ]+" IS_INT16 "${TRIMMED_KEY}")
  string(REGEX MATCH "^SETTINGS_DEPRECATED\\(ALIGN64[ \t ]+UINT16[ \t ]+" IS_UINT16 "${TRIMMED_KEY}")
  string(REGEX MATCH "^SETTINGS_DEPRECATED\\(ALIGN64[ \t ]+INT32[ \t ]+" IS_INT32 "${TRIMMED_KEY}")
  string(REGEX MATCH "^SETTINGS_DEPRECATED\\(ALIGN64[ \t ]+UINT32[ \t ]+" IS_UINT32 "${TRIMMED_KEY}")
  string(REGEX MATCH "^SETTINGS_DEPRECATED\\(ALIGN64[ \t ]+INT64[ \t ]+" IS_INT64 "${TRIMMED_KEY}")
  string(REGEX MATCH "^SETTINGS_DEPRECATED\\(ALIGN64[ \t ]+UINT64[ \t ]+" IS_UINT64 "${TRIMMED_KEY}")
  string(REGEX MATCH "^SETTINGS_DEPRECATED\\(ALIGN64[ \t ]+(char|CHAR)[ \t ]*\\*[ \t ]+" IS_STRING "${TRIMMED_KEY}")

  string(REGEX REPLACE ".+/\\*" "" index "${TRIMMED_KEY}")
  string(REGEX REPLACE "[ \t/\\*]" "" index "${index}")

  if(index MATCHES "^[0-9]+$")
    string(REGEX REPLACE "^SETTINGS_DEPRECATED\\(ALIGN64[ \t ]+[a-zA-Z0-9_\\*]+[ \t ]+" "" VALUE ${TRIMMED_KEY})
    string(STRIP "${VALUE}" VALUE)
    string(FIND "${VALUE}" ")" SEMICOLON)
    string(SUBSTRING "${VALUE}" 0 ${SEMICOLON} KEY_VALUE)

    if(IS_BOOL)
      set(KEY_VALUE "FreeRDP_${KEY_VALUE} = ${index}")
      list(APPEND SETTINGS_KEYS_BOOL ${KEY_VALUE})
    elseif(IS_INT16)
      set(KEY_VALUE "FreeRDP_${KEY_VALUE} = ${index}")
      list(APPEND SETTINGS_KEYS_INT16 ${KEY_VALUE})
    elseif(IS_UINT16)
      set(KEY_VALUE "FreeRDP_${KEY_VALUE} = ${index}")
      list(APPEND SETTINGS_KEYS_UINT16 ${KEY_VALUE})
    elseif(IS_INT32)
      set(KEY_VALUE "FreeRDP_${KEY_VALUE} = ${index}")
      list(APPEND SETTINGS_KEYS_INT32 ${KEY_VALUE})
    elseif(IS_UINT32)
      set(KEY_VALUE "FreeRDP_${KEY_VALUE} = ${index}")
      list(APPEND SETTINGS_KEYS_UINT32 ${KEY_VALUE})
    elseif(IS_INT64)
      set(KEY_VALUE "FreeRDP_${KEY_VALUE} = ${index}")
      list(APPEND SETTINGS_KEYS_INT64 ${KEY_VALUE})
    elseif(IS_UINT64)
      set(KEY_VALUE "FreeRDP_${KEY_VALUE} = ${index}")
      list(APPEND SETTINGS_KEYS_UINT64 ${KEY_VALUE})
    elseif(IS_STRING)
      string(SUBSTRING "${VALUE}" 0 ${SEMICOLON} KEY_VALUE)
      set(KEY_VALUE "FreeRDP_${KEY_VALUE} = ${index}")
      list(APPEND SETTINGS_KEYS_STRING ${KEY_VALUE})
    else()
      set(KEY_VALUE "FreeRDP_${KEY_VALUE} = ${index}")
      list(APPEND SETTINGS_KEYS_POINTER ${KEY_VALUE})
    endif()
  endif()
endforeach()

list(APPEND SETTINGS_KEYS_BOOL "FreeRDP_BOOL_UNUSED = -1")
list(APPEND SETTINGS_KEYS_INT16 "FreeRDP_INT16_UNUSED = -1")
list(APPEND SETTINGS_KEYS_UINT16 "FreeRDP_UINT16_UNUSED = -1")
list(APPEND SETTINGS_KEYS_INT32 "FreeRDP_INT32_UNUSED = -1")
list(APPEND SETTINGS_KEYS_UINT32 "FreeRDP_UINT32_UNUSED = -1")
list(APPEND SETTINGS_KEYS_INT64 "FreeRDP_INT64_UNUSED = -1")
list(APPEND SETTINGS_KEYS_UINT64 "FreeRDP_UINT64_UNUSED = -1")
list(APPEND SETTINGS_KEYS_STRING "FreeRDP_STRING_UNUSED = -1")
list(APPEND SETTINGS_KEYS_POINTER "FreeRDP_POINTER_UNUSED = -1")

string(REPLACE ";" ",\n\t" SETTINGS_KEYS_BOOL "${SETTINGS_KEYS_BOOL}")
string(REPLACE ";" ",\n\t" SETTINGS_KEYS_INT16 "${SETTINGS_KEYS_INT16}")
string(REPLACE ";" ",\n\t" SETTINGS_KEYS_UINT16 "${SETTINGS_KEYS_UINT16}")
string(REPLACE ";" ",\n\t" SETTINGS_KEYS_INT32 "${SETTINGS_KEYS_INT32}")
string(REPLACE ";" ",\n\t" SETTINGS_KEYS_UINT32 "${SETTINGS_KEYS_UINT32}")
string(REPLACE ";" ",\n\t" SETTINGS_KEYS_INT64 "${SETTINGS_KEYS_INT64}")
string(REPLACE ";" ",\n\t" SETTINGS_KEYS_UINT64 "${SETTINGS_KEYS_UINT64}")
string(REPLACE ";" ",\n\t" SETTINGS_KEYS_STRING "${SETTINGS_KEYS_STRING}")
string(REPLACE ";" ",\n\t" SETTINGS_KEYS_POINTER "${SETTINGS_KEYS_POINTER}")

cleaning_configure_file(
  ${CMAKE_CURRENT_SOURCE_DIR}/config/settings_keys.h.in ${CMAKE_CURRENT_BINARY_DIR}/freerdp/settings_keys.h
)

file(GLOB_RECURSE PUBLIC_COMMON_HEADERS LIST_DIRECTORIES false "freerdp/*.h")
if(WITHOUT_FREERDP_3x_DEPRECATED)
  list(REMOVE_ITEM PUBLIC_COMMON_HEADERS "${CMAKE_CURRENT_SOURCE_DIR}/freerdp/crypto/er.h")
  list(REMOVE_ITEM PUBLIC_COMMON_HEADERS "${CMAKE_CURRENT_SOURCE_DIR}/freerdp/crypto/der.h")
endif()

file(GLOB_RECURSE PUBLIC_COMMON_BIN_HEADERS LIST_DIRECTORIES false "${CMAKE_CURRENT_BINARY_DIR}/freerdp/*.h")
list(SORT PUBLIC_COMMON_HEADERS)

if(WITH_SERVER)
  set(PUBLIC_SERVER_HEADERS ${PUBLIC_COMMON_HEADERS})
  list(FILTER PUBLIC_SERVER_HEADERS INCLUDE REGEX ".*freerdp/server.*")

  set(PUBLIC_PROXY_HEADERS ${PUBLIC_SERVER_HEADERS})
  list(FILTER PUBLIC_SERVER_HEADERS EXCLUDE REGEX ".*freerdp/server/proxy.*")
  list(FILTER PUBLIC_PROXY_HEADERS INCLUDE REGEX ".*freerdp/server/proxy.*")
  if(WITH_SERVER)
    set_property(TARGET freerdp-server APPEND PROPERTY SOURCES ${PUBLIC_SERVER_HEADERS})
  endif()
  if(WITH_PROXY)
    set_property(TARGET freerdp-server-proxy APPEND PROPERTY SOURCES ${PUBLIC_PROXY_HEADERS})
  endif()
endif()

if(WITH_CLIENT_COMMON)
  set(PUBLIC_CLIENT_HEADERS ${PUBLIC_COMMON_HEADERS})
  list(FILTER PUBLIC_CLIENT_HEADERS INCLUDE REGEX ".*freerdp/client.*")
  set_property(TARGET freerdp-client APPEND PROPERTY SOURCES ${PUBLIC_CLIENT_HEADERS})
endif()

if(WITH_SERVER)
  list(FILTER PUBLIC_COMMON_HEADERS EXCLUDE REGEX ".*freerdp/server.*")
endif()

list(FILTER PUBLIC_COMMON_HEADERS EXCLUDE REGEX ".*freerdp/client.*")
list(APPEND PUBLIC_COMMON_HEADERS ${PUBLIC_COMMON_BIN_HEADERS})
set_property(TARGET freerdp APPEND PROPERTY SOURCES ${PUBLIC_COMMON_HEADERS})

add_library(freerdp-headers INTERFACE)
target_sources(freerdp-headers INTERFACE ${PUBLIC_COMMON_HEADERS})

install(DIRECTORY ${CMAKE_CURRENT_SOURCE_DIR}/freerdp DESTINATION ${FREERDP_INCLUDE_DIR} FILES_MATCHING PATTERN "*.h")

install(DIRECTORY ${CMAKE_CURRENT_BINARY_DIR}/freerdp DESTINATION ${FREERDP_INCLUDE_DIR} FILES_MATCHING PATTERN "*.h")

=== libfreerdp/crypto/CMakeLists.txt ===
# FreeRDP: A Remote Desktop Protocol Implementation
# libfreerdp-crypto cmake build script
#
# Copyright 2012 Marc-Andre Moreau <marcandre.moreau@gmail.com>
#
# Licensed under the Apache License, Version 2.0 (the "License");
# you may not use this file except in compliance with the License.
# You may obtain a copy of the License at
#
#     http://www.apache.org/licenses/LICENSE-2.0
#
# Unless required by applicable law or agreed to in writing, software
# distributed under the License is distributed on an "AS IS" BASIS,
# WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
# See the License for the specific language governing permissions and
# limitations under the License.

set(MODULE_NAME "freerdp-crypto")
set(MODULE_PREFIX "FREERDP_CRYPTO")

freerdp_module_add(
  ber.c
  per.c
  base64.c
  x509_utils.c
  x509_utils.h
  cert_common.h
  cert_common.c
  privatekey.c
  privatekey.h
  certificate.c
  certificate.h
  certificate_data.c
  certificate_store.c
  crypto.c
  tls.c
  tls.h
  opensslcompat.c
)

if(NOT WITHOUT_FREERDP_3x_DEPRECATED)
  freerdp_module_add(er.c der.c)
endif()

freerdp_include_directory_add(${OPENSSL_INCLUDE_DIR})

freerdp_library_add(${OPENSSL_LIBRARIES})
freerdp_pc_add_requires_private("libssl")

if(MBEDTLS_FOUND)
  freerdp_include_directory_add(${MBEDTLS_INCLUDE_DIR})
  freerdp_library_add(${MBEDTLS_LIBRARIES})
  freerdp_pc_add_requires_private("mbedtls")
endif()

if(WIN32)
  freerdp_library_add(ws2_32)
endif()

if(BUILD_TESTING_INTERNAL OR BUILD_TESTING)
  add_subdirectory(test)
endif()

=== channels/rdpdr/server/CMakeLists.txt ===
# FreeRDP: A Remote Desktop Protocol Implementation
# FreeRDP cmake build script
#
# Copyright 2012 Marc-Andre Moreau <marcandre.moreau@gmail.com>
#
# Licensed under the Apache License, Version 2.0 (the "License");
# you may not use this file except in compliance with the License.
# You may obtain a copy of the License at
#
#     http://www.apache.org/licenses/LICENSE-2.0
#
# Unless required by applicable law or agreed to in writing, software
# distributed under the License is distributed on an "AS IS" BASIS,
# WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
# See the License for the specific language governing permissions and
# limitations under the License.

define_channel_server("rdpdr")

set(${MODULE_PREFIX}_SRCS rdpdr_main.c rdpdr_main.h)

set(${MODULE_PREFIX}_LIBS freerdp)

option(WITH_WCHAR_FILE_DIRECTORY_INFORMATION "Build with WCHAR FILE_DIRECTORY_INFORMATION::FileName" OFF)
add_channel_server_library(${MODULE_PREFIX} ${MODULE_NAME} ${CHANNEL_NAME} FALSE "VirtualChannelEntry")

=== channels/rdpecam/server/CMakeLists.txt ===
# FreeRDP: A Remote Desktop Protocol Implementation
# FreeRDP cmake build script
#
# Copyright 2022 Pascal Nowack <Pascal.Nowack@gmx.de>
#
# Licensed under the Apache License, Version 2.0 (the "License");
# you may not use this file except in compliance with the License.
# You may obtain a copy of the License at
#
#     http://www.apache.org/licenses/LICENSE-2.0
#
# Unless required by applicable law or agreed to in writing, software
# distributed under the License is distributed on an "AS IS" BASIS,
# WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
# See the License for the specific language governing permissions and
# limitations under the License.

define_channel_server("rdpecam")

set(${MODULE_PREFIX}_SRCS camera_device_enumerator_main.c camera_device_main.c rdpecam-utils.h)

set(${MODULE_PREFIX}_LIBS freerdp)

add_channel_server_library(${MODULE_PREFIX} ${MODULE_NAME} ${CHANNEL_NAME} FALSE "DVCPluginEntry")

=== client/SDL/SDL3/CMakeLists.txt ===
# FreeRDP: A Remote Desktop Protocol Implementation
# FreeRDP SDL Client
#
# Copyright 2022 Armin Novak <anovak@thincast.com>
# Copyright 2024 Armin Novak <anovak@thincast.com>
# Copyright 2024 Thincast Technologies GmbH
#
# Licensed under the Apache License, Version 2.0 (the "License");
# you may not use this file except in compliance with the License.
# You may obtain a copy of the License at
#
#     http://www.apache.org/licenses/LICENSE-2.0
#
# Unless required by applicable law or agreed to in writing, software
# distributed under the License is distributed on an "AS IS" BASIS,
# WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
# See the License for the specific language governing permissions and
# limitations under the License.
set(MODULE_NAME "sdl3-freerdp")

find_package(SDL3 REQUIRED)

find_package(Threads REQUIRED)

add_subdirectory(dialogs)
set(SRCS
    sdl_types.hpp
    sdl_utils.cpp
    sdl_utils.hpp
    sdl_input.cpp
    sdl_input.hpp
    sdl_touch.cpp
    sdl_touch.hpp
    sdl_pointer.cpp
    sdl_pointer.hpp
    sdl_disp.cpp
    sdl_disp.hpp
    sdl_monitor.cpp
    sdl_monitor.hpp
    sdl_freerdp.hpp
    sdl_freerdp.cpp
    sdl_channels.hpp
    sdl_channels.cpp
    sdl_window.hpp
    sdl_window.cpp
    sdl_clip.hpp
    sdl_clip.cpp
    sdl_context.hpp
    sdl_context.cpp
)

list(
  APPEND
  LIBS
  winpr
  freerdp
  freerdp-client
  Threads::Threads
  sdl3_client_res
  sdl3-dialogs
  sdl-common-aad-view
  sdl-common-prefs
)

if(NOT WITH_SDL_LINK_SHARED)
  list(APPEND LIBS SDL3::SDL3-static)
else()
  list(APPEND LIBS SDL3::SDL3)
endif()
set_target_properties(SDL3::Headers PROPERTIES SYSTEM TRUE)

include_directories(${CMAKE_CURRENT_BINARY_DIR})

addtargetwithresourcefile(${MODULE_NAME} "${WIN32_GUI_FLAG}" "${PROJECT_VERSION}" SRCS)

target_link_libraries(${MODULE_NAME} PRIVATE ${LIBS})

set_property(TARGET ${MODULE_NAME} PROPERTY FOLDER "Client/SDL")
get_target_property(SDL_CLIENT_BINARY_NAME ${MODULE_NAME} OUTPUT_NAME)
if(NOT WITH_CLIENT_SDL_VERSIONED)
  string(REPLACE "${MODULE_NAME}" "${PROJECT_NAME}" SDL_CLIENT_BINARY_NAME "${SDL_CLIENT_BINARY_NAME}")
  set_target_properties(${MODULE_NAME} PROPERTIES OUTPUT_NAME ${SDL_CLIENT_BINARY_NAME})
endif()

string(TIMESTAMP SDL_CLIENT_YEAR "%Y")
set(SDL_CLIENT_UUID "com.freerdp.client.sdl3")
configure_file(${CMAKE_CURRENT_SOURCE_DIR}/sdl_config.hpp.in ${CMAKE_CURRENT_BINARY_DIR}/sdl_config.hpp @ONLY)

installwithrpath(TARGETS ${MODULE_NAME} DESTINATION ${CMAKE_INSTALL_BINDIR} COMPONENT client)
install_freerdp_desktop("${MODULE_NAME}" "${SDL_CLIENT_UUID}")

add_subdirectory(man)

=== debian/changelog ===
freerdp3 (3.22.0+dfsg-3) unstable; urgency=medium

  * d/control: add libwinpr3-3:Replaces: libwinpr2-2 to override wlog.7.
    There's no upgrade path from freerdp2 in bookworm to freerdp3 in trixie,
    so if the user had freerdp2 installed in bookworm and upgraded the system
    to trixie, it is very likely they still have freerdp2 installed (obsolete
    package).  And the new libwinp3-3 ships the same manpage as the old
    libwinpr2-2.  Allow replacing this file when installing new libwinpr3-3.
    Do not add Breaks: though, since this way, all freerdp2 packages has to
    be removed (which might be a good thing in the end, but for that we ought
    to provide xfreerdp2 etc binaries too).  Also Breaks libwinpr2-2t64, since
    apparently some users managed to install the t64 packages on a bookworm
    system somehow.  (Closes: #1127622)
  * rename source package back to freerdp3.  It turned out this is too much
    pain (security tracker, bug reports, autopkgtests, etc) for nothing.
    Suggest renaming it to freerdp at freerdp4 time.

 -- Michael Tokarev <mjt@tls.msk.ru>  Wed, 11 Feb 2026 12:08:45 +0300

freerdp (3.22.0+dfsg-2) unstable; urgency=medium

  * package rename.  We had freerdp, freerdp2, freerdp3, - due to big rewrite
    upstream from 1.x to 2.x which was going in parallel with 1.x, and it was
    unclear when 2.x will be ready.  Next, during 2.x to 3.x, it was a steady
    update, which stayed compatible with 2.x series.  But the project itself
    is named "freerdp" without any version suffix.  And we had no upgrade path
    from bookworm (which has freerdp2 only) to trixie (freerdp3 only).  There's
    no actual reason to carry the suffix, at least not anymore.  Let's name it
    "freerdp" without any suffix, and provide compatibility end-user packages
    with compatibility naming.  Rename source package from freerdp3 to freerdp
  * rename end-user binary packages: freerdp3-x11, freerdp3-sdl,
    freerdp3-wayland, freerdp3-proxy, freerdp3-proxy-modules, winpr3-utils
    to drop the "3" version suffix from both the name of the package and
    the name of the binary.  Provide transitional packages with old names,
    containing symlinks to new binaries
  * update CVE references in the previous changelog entry

 -- Michael Tokarev <mjt@tls.msk.ru>  Tue, 10 Feb 2026 12:24:09 +0300

freerdp3 (3.22.0+dfsg-1) unstable; urgency=medium

  * new upstream major bugfix release, with overhaul of SDL3 client and
    multiple security fixes for the following client-side vulnerabilities:
    CVE-2026-23948 NULL Pointer Dereference in rdp_write_logon_info_v2()
      https://github.com/FreeRDP/FreeRDP/security/advisories/GHSA-6f3c-qvqq-2px5
    CVE-2026-24491 Heap-use-after-free in video_timer
      https://github.com/FreeRDP/FreeRDP/security/advisories/GHSA-4x6j-w49r-869g
    CVE-2026-24675 Heap-use-after-free in urb_select_interface
      https://github.com/FreeRDP/FreeRDP/security/advisories/GHSA-x9jr-99h2-g7mj
    CVE-2026-24676 Heap-use-after-free in audio_format_compatible
      https://github.com/FreeRDP/FreeRDP/security/advisories/GHSA-qh5p-frq4-pgxj
    CVE-2026-24677 Heap-buffer-overflow in ecam_encoder_compress_h264
      https://github.com/FreeRDP/FreeRDP/security/advisories/GHSA-xw37-j744-f8v7
    CVE-2026-24678 Heap-use-after-free in cam_v4l_stream_capture_thread
      https://github.com/FreeRDP/FreeRDP/security/advisories/GHSA-6gvg-29wx-6v7h
    CVE-2026-24679 Heap-buffer-overflow in urb_select_interface
      https://github.com/FreeRDP/FreeRDP/security/advisories/GHSA-2jp4-67x6-gv7x
    CVE-2026-24680 Heap-use-after-free in update_pointer_new(SDL)
      https://github.com/FreeRDP/FreeRDP/security/advisories/GHSA-j893-9wg8-33rc
    CVE-2026-24681 Heap-use-after-free in urb_bulk_transfer_cb
      https://github.com/FreeRDP/FreeRDP/security/advisories/GHSA-ccvv-hg2w-6x9j
    CVE-2026-24682 Heap-buffer-overflow in audio_formats_free
      https://github.com/FreeRDP/FreeRDP/security/advisories/GHSA-vcw2-pqgw-mx6g
    CVE-2026-24683 Heap-use-after-free in ainput_send_input_event
      https://github.com/FreeRDP/FreeRDP/security/advisories/GHSA-45pf-68pj-fg8q
    CVE-2026-24684 Heap-use-after-free in play_thread
      https://github.com/FreeRDP/FreeRDP/security/advisories/GHSA-vcgv-xgjp-h83q
  * update libfreerdp symbols file (add new symbols)

 -- Michael Tokarev <mjt@tls.msk.ru>  Thu, 29 Jan 2026 11:22:26 +0300

=== debian/control ===
Source: freerdp3
Section: x11
Priority: optional
Maintainer: Debian Remote Maintainers <debian-remote@lists.debian.org>
Uploaders:
 Mike Gabriel <sunweaver@debian.org>,
 Bernhard Miklautz <bernhard.miklautz@shacknet.at>,
 Michael Tokarev <mjt@tls.msk.ru>,
Build-Depends:
 debhelper-compat (= 13),
Build-Depends-Arch:
 cmake,
 dpkg-dev (>= 1.22.5),
 libasound2-dev,
# ffmpeg is in universe in ubuntu (not enabled):
 libavcodec-dev, libavutil-dev, libswscale-dev,
# cairo is used on ubuntu only (alternative to swscale from ffmpeg):
 libcairo2-dev,
 libjson-c-dev,
 libcups2-dev,
 libfuse3-dev,
 libgsm1-dev,
 libicu-dev,
 libjpeg-dev,
 libkrb5-dev,
 libopus-dev,
 libpam0g-dev,
 libpcsclite-dev,
 libpng-dev,
 libpulse-dev,
 libsdl2-dev <pkg.freerdp3.sdl2>,
 libsdl2-image-dev <pkg.freerdp3.sdl2>,
 libsdl2-ttf-dev <pkg.freerdp3.sdl2>,
 libsdl3-dev <!pkg.freerdp3.sdl2>,
 libsdl3-image-dev <!pkg.freerdp3.sdl2>,
 libsdl3-ttf-dev <!pkg.freerdp3.sdl2>,
 libssl-dev,
 libv4l-dev [linux-any],
 libswresample-dev,
 libsystemd-dev [linux-any],
 libudev-dev [linux-any],
 libusb-1.0-0-dev [linux-any],
 liburiparser-dev,
 libwayland-dev [linux-any],
 libwebp-dev,
 libx11-dev,
 libxcursor-dev,
 libxdamage-dev,
 libxext-dev,
 libxfixes-dev,
 libxinerama-dev,
 libxi-dev,
 libxkbcommon-dev,
 libxkbfile-dev,
 libxrandr-dev,
 libxrender-dev,
 libxtst-dev,
 libxv-dev,
 pkgconf,
 uuid-dev,
 xmlto,
 xsltproc,
Standards-Version: 4.7.2
Rules-Requires-Root: no
Homepage: https://www.freerdp.com/
Vcs-Browser: https://salsa.debian.org/debian-remote-team/freerdp3
Vcs-Git: https://salsa.debian.org/debian-remote-team/freerdp3.git

Package: freerdp-x11
Architecture: any
Depends:
 ${misc:Depends},
 ${shlibs:Depends},
 libfreerdp-client3-3 (= ${binary:Version}),
Provides:
 freerdp,
Description: RDP client for Windows Terminal Services (X11 client)
 FreeRDP is a libre client/server implementation of the Remote
 Desktop Protocol (RDP).
 .
 This package contains the X11 based client.

Package: freerdp3-x11
Architecture: all
Depends: freerdp-x11 (>> ${source:Version}~)
Section: oldlibs
Description: RDP client for Windows Terminal Services (X11 client tramsitional package)
 FreeRDP is a libre client/server implementation of the Remote
 Desktop Protocol (RDP).
 .
 This package provides compatibility links for transition from freerdp3-x11
 (xfreerdp3 binary) to freerdp-x11 (xfreerdp binary).

Package: libfreerdp3-3
Architecture: any
Section: libs
Depends:
 ${misc:Depends},
 ${shlibs:Depends},
 libwinpr3-3 (= ${binary:Version}),
Multi-Arch: same
Suggests:
 freerdp-x11,
Description: Free Remote Desktop Protocol library (core library)
 FreeRDP is a libre client/server implementation of the Remote
 Desktop Protocol (RDP).
 .
 This package contains the shared library with all core functionality.

Package: libfreerdp-client3-3
Architecture: any
Section: libs
Depends:
 ${misc:Depends},
 ${shlibs:Depends},
 libfreerdp3-3 (= ${binary:Version}),
Multi-Arch: same
Description: Free Remote Desktop Protocol library (client library)
 FreeRDP is a libre client/server implementation of the Remote
 Desktop Protocol (RDP).
 .
 This package contains the shared library for common client functionality.

Package: libfreerdp-server3-3
Architecture: any
Section: libs
Depends:
 ${misc:Depends},
 ${shlibs:Depends},
 libfreerdp3-3 (= ${binary:Version}),
Multi-Arch: same
Description: Free Remote Desktop Protocol library (server library)
 FreeRDP is a libre client/server implementation of the Remote
 Desktop Protocol (RDP).
 .
 This package contains the shared library with common server functionality.

Package: libwinpr3-3
Architecture: any
Section: libs
Depends:
 ${misc:Depends},
 ${shlibs:Depends},
Multi-Arch: same
Suggests:
 freerdp-x11,
Replaces:
# #1127622.  No Breaks, - it is just for wlog.7 manpage
 libwinpr2-2, libwinpr2-2t64
Description: Windows Portable Runtime library
 WinPR is a spin-off project of FreeRDP which aims at providing a portable
 implementation of important portions of the Windows API. Just like FreeRDP,
 WinPR is released under the Apache license. Unlike Wine, WinPR does not provide
 binary compatibility, and does not require applications to be built for
 Windows. Instead, WinPR provides API compatibility for applications targeting
 non-Windows environments. When on Windows, the original native API is being
 used instead of the equivalent WinPR implementation, without having to modify
 the code using it.
 .
 This package contains the WinPR shared library.

Package: libwinpr-tools3-3
Architecture: any
Section: libs
Depends:
 ${misc:Depends},
 ${shlibs:Depends},
 libwinpr3-3 (= ${binary:Version}),
Multi-Arch: same
Description: Windows Portable Runtime Tools library
 FreeRDP is a libre client/server implementation of the Remote
 Desktop Protocol (RDP).
 .
 This package contains the shared library for Windows Portable Runtime
 utilities and tools.

Package: libwinpr3-dev
Section: libdevel
Architecture: any
Depends:
 libssl-dev,
 libjson-c-dev,
 libwinpr-tools3-3 (= ${binary:Version}),
 libwinpr3-3 (= ${binary:Version}),
 ${misc:Depends},
Description: Windows Portable Runtime library (development files)
 WinPR is a spin-off project of FreeRDP which aims at providing a portable
 implementation of important portions of the Windows API. Just like FreeRDP,
 WinPR is released under the Apache license. Unlike Wine, WinPR does not provide
 binary compatibility, and does not require applications to be built for
 Windows. Instead, WinPR provides API compatibility for applications targeting
 non-Windows environments. When on Windows, the original native API is being
 used instead of the equivalent WinPR implementation, without having to modify
 the code using it.
 .
 This package contains the WinPR development files.

Package: freerdp3-dev
Section: devel
Architecture: any
Depends:
 libfreerdp-server-proxy3-3 (= ${binary:Version}),
 libfreerdp-client3-3 (= ${binary:Version}),
 libfreerdp-server3-3 (= ${binary:Version}),
 libfreerdp-shadow-subsystem3-3 (= ${binary:Version}),
 libfreerdp-shadow3-3 (= ${binary:Version}),
 libfreerdp3-3 (= ${binary:Version}),
 libwinpr3-dev (= ${binary:Version}),
 libwinpr3-3 (= ${binary:Version}),
 libfuse3-dev,
 winpr-utils (= ${binary:Version}),
 ${misc:Depends},
Description: Free Remote Desktop Protocol library (development files)
 FreeRDP is a libre client/server implementation of the Remote
 Desktop Protocol (RDP).
 .
 This package contains the FreeRDP development files.

Package: winpr-utils
Multi-Arch: foreign
Section: utils
Architecture: any
Depends:
 ${misc:Depends},
 ${shlibs:Depends},
 libwinpr-tools3-3 (= ${binary:Version}),
Description: Windows Portable Runtime library command line utilities
 WinPR is a spin-off project of FreeRDP which aims at providing a portable
 implementation of important portions of the Windows API. Just like FreeRDP,
 WinPR is released under the Apache license. Unlike Wine, WinPR does not provide
 binary compatibility, and does not require applications to be built for
 Windows. Instead, WinPR provides API compatibility for applications targeting
 non-Windows environments. When on Windows, the original native API is being
 used instead of the equivalent WinPR implementation, without having to modify
 the code using it.
 .
 This package contains WinPR command line utils (winpr-hash, winpr-makecert).

Package: winpr3-utils
Architecture: all
Depends: winpr-utils
Section: oldlibs
Description: Windows Portable Runtime library command line utilities (transitional package)
 This package provides compatibility links for transition from winpr3-utils
 to winpr-utils.

Package: libfreerdp-shadow3-3
Architecture: any
Section: libs
Depends:
 ${misc:Depends},
 ${shlibs:Depends},
 libfreerdp-server3-3 (= ${binary:Version}),
 libwinpr-tools3-3 (= ${binary:Version}),
Multi-Arch: same
Description: FreeRDP Remote Desktop Protocol shadow libraries
 FreeRDP is a libre client/server implementation of the Remote
 Desktop Protocol (RDP).
 .
 This package contains the shadow libraries.

Package: libfreerdp-shadow-subsystem3-3
Architecture: any
Section: libs
Depends:
 ${misc:Depends},
 ${shlibs:Depends},
 libfreerdp-shadow3-3 (= ${binary:Version}),
Multi-Arch: same
Description: FreeRDP Remote Desktop Protocol shadow subsystem libraries
 FreeRDP is a libre client/server implementation of the Remote
 Desktop Protocol (RDP).
 .
 This package contains the shadow subsystem libraries.

Package: freerdp-shadow-x11
Architecture: any
Depends:
 ${misc:Depends},
 ${shlibs:Depends},
 libfreerdp-shadow-subsystem3-3 (= ${binary:Version}),
Provides:
 freerdp,
Description: FreeRDP x11 shadowing server
 FreeRDP is a libre client/server implementation of the Remote
 Desktop Protocol (RDP).
 .
 This package contains a "shadowing" server that can be used to
 share an already started X11 DISPLAY.

Package: freerdp3-shadow-x11
Architecture: all
Depends: freerdp-shadow-x11 (>> ${source:Version}~)
Section: oldlibs
Description: FreeRDP x11 shadowing server (transitional package)
 FreeRDP is a libre client/server implementation of the Remote
 Desktop Protocol (RDP).
 .
 This package provides compatibility links for transition from
 freerdp3-shadow-x11 (freerdp-shadow-cli3 binary) to freerdp-shadow-x11
 (freerdp-shadow-cli binary).

Package: freerdp-wayland
Architecture: linux-any
Depends:
 ${misc:Depends},
 ${shlibs:Depends},
 libfreerdp-client3-3 (= ${binary:Version}),
 libwinpr3-3 (= ${binary:Version}),
Description: RDP client for Windows Terminal Services (wayland client)
 FreeRDP is a libre client/server implementation of the Remote
 Desktop Protocol (RDP).
 .
 This package contains the wayland based client.

Package: freerdp3-wayland
Architecture: all
Depends: freerdp-wayland (>> ${source:Version}~)
Section: oldlibs
Description: RDP client for Windows Terminal Services (wayland client transitional package)
 FreeRDP is a libre client/server implementation of the Remote
 Desktop Protocol (RDP).
 .
 This package provides compatibility links for transition from freerdp3-wayland
 (wlfreerdp3 binary) to freerdp-wayland (wlfreerdp binary).

Package: freerdp-sdl
Architecture: any
Depends:
 ${misc:Depends},
 ${shlibs:Depends},
 libfreerdp-client3-3 (= ${binary:Version}),
Description: RDP client for Windows Terminal Services (SDL client)
 FreeRDP is a libre client/server implementation of the Remote
 Desktop Protocol (RDP).
 .
 This package contains the SDL based client.

Package: freerdp3-sdl
Architecture: all
Depends: freerdp-sdl (>> ${source:Version}~)
Section: oldlibs
Description: RDP client for Windows Terminal Services (SDL client transitional package)
 FreeRDP is a libre client/server implementation of the Remote
 Desktop Protocol (RDP).
 .
 This package provides compatibility links for transition from freerdp3-sdl
 (sdl-freerdp3 binary) to freerdp-sdl (sdl-freerdp binary).

Package: libfreerdp-server-proxy3-3
Architecture: any
Section: libs
Depends:
 ${misc:Depends},
 ${shlibs:Depends},
 libfreerdp3-3 (= ${binary:Version}),
 libfreerdp-client3-3 (= ${binary:Version}),
 libwinpr3-3 (= ${binary:Version}),
Multi-Arch: same
Description: Free Remote Desktop Protocol library (proxy library)
 FreeRDP is a libre client/server implementation of the Remote
 Desktop Protocol (RDP).
 .
 This package contains the shared library for proxying RDP connections.

Package: freerdp-proxy-modules
Architecture: any
Depends:
 ${misc:Depends},
 ${shlibs:Depends},
 libfreerdp-server-proxy3-3 (= ${binary:Version}),
Description: FreeRDP Remote Desktop Protocol proxy module libraries
 FreeRDP is a libre client/server implementation of the Remote
 Desktop Protocol (RDP).
 .
 This package contains the modules for the proxy.

Package: freerdp-proxy
Architecture: any
Depends:
 ${misc:Depends},
 ${shlibs:Depends},
 libfreerdp-server-proxy3-3 (= ${binary:Version}),
 libfreerdp3-3 (= ${binary:Version}),
 libwinpr3-3 (= ${binary:Version}),
Suggests:
 freerdp-proxy-modules,
Description: FreeRDP proxy server

=== debian/rules ===
#!/usr/bin/make -f

include /usr/share/dpkg/default.mk

export DEB_BUILD_MAINT_OPTIONS = hardening=+all
export DPKG_GENSYMBOLS_CHECK_LEVEL = 4
DPKG_EXPORT_BUILDFLAGS = 1

CFLAGS   += $(CPPFLAGS) -DNDEBUG
CXXFLAGS += $(CPPFLAGS) -DNDEBUG

empty :=

DEB_CMAKE_EXTRA_FLAGS = \
    -DGIT_REVISION=DEB_VERSION_REVISION \
    -DCMAKE_INSTALL_INCLUDEDIR=include/$(DEB_HOST_MULTIARCH) \
    -DCMAKE_SKIP_RPATH=FALSE \
    -DCMAKE_SKIP_INSTALL_RPATH=TRUE \
    -DCMAKE_BUILD_TYPE=RelWithDebInfo \
    -DWITH_DEBUG_ALL=OFF \
    -DBUILD_TESTING=ON \
    -DWITH_CHANNELS=ON \
    -DWITH_SERVER=ON \
    -DWITH_PROXY=ON \
    -DWITH_PROXY_MODULES=ON \
    -DWITH_CLIENT_INTERFACE=OFF \
    -DWITH_CLIENT_SDL=ON \
    -DWITH_CLIENT_SDL_VERSIONED=OFF \
    -DWITH_CLIENT_SDL2=$(if $(filter pkg.freerdp3.sdl2,${DEB_BUILD_PROFILES}),ON,OFF) \
    -DWITH_CLIENT_SDL3=$(if $(filter pkg.freerdp3.sdl2,${DEB_BUILD_PROFILES}),OFF,ON) \
    -DWITH_SDL_IMAGE_DIALOGS=ON \
    -DWITH_WEBVIEW=OFF \
    -DWITH_PULSE=ON \
    -DWITH_ICU=ON \
    -DWITH_CUPS=ON \
    -DWITH_PCSC=ON \
    -DWITH_JPEG=ON \
    -DWITH_KERBEROS=ON \
    -DCHANNEL_RDP2TCP=ON -DCHANNEL_RDP2TCP_CLIENT=ON \
    -DCHANNEL_RDPEAR=ON -DCHANNEL_RDPEAR_CLIENT=ON \
    -DWITH_CLANG_FORMAT=OFF \
    -DWITH_OPUS=ON \
    -DWITH_SAMPLE=OFF \
    -DWITH_OPENSC_PKCS11_LINKED=OFF \
    -DWITH_VAAPI=OFF \
    -DWITH_WINPR_UTILS_IMAGE_JPEG=ON \
    -DWITH_WINPR_UTILS_IMAGE_PNG=ON \
    -DWITH_WINPR_UTILS_IMAGE_WEBP=ON \
    -DWITH_SMARTCARD_EMULATE=ON \
    -DRDTK_FORCE_STATIC_BUILD=ON \
    -DUWAC_FORCE_STATIC_BUILD=ON \
    -DWITH_BINARY_VERSIONING=OFF \
    -DWITH_VERBOSE_WINPR_ASSERT=OFF \
    -DWITH_INSTALL_CLIENT_DESKTOP_FILES=ON \
    -DWITH_JSONC_REQUIRED=ON \
    $(empty)

ifneq (,$(filter armel,$(DEB_HOST_ARCH)))
    DEB_CMAKE_EXTRA_FLAGS += \
        -DWITH_NEON=OFF \
        $(empty)
endif

ifneq (,$(filter armel armhf,$(DEB_HOST_ARCH)))
# https://github.com/FreeRDP/FreeRDP/issues/10353
# gcc/glibc does not provide _URC_NORMAL_STOP etc definitions in
# <unwind.h> on armel armhf
# it's proabbly be better to perform a build-time check instead
# -DWITH_UNWIND=OFF does not work in version 3.6
    DEB_CMAKE_EXTRA_FLAGS += \
        -DWINPR_HAVE_UNWIND_H=OFF \
        $(empty)
endif

ifneq (,$(filter linux,$(DEB_HOST_ARCH_OS)))
    DEB_CMAKE_EXTRA_FLAGS += \
        -DCHANNEL_URBDRC=ON \
        -DCHANNEL_URBDRC_CLIENT=ON \
        -DWITH_WAYLAND=ON \
        -DWITH_VAAPI_H264_ENCODING=ON \
        -DCHANNEL_RDPECAM=ON \
        -DCHANNEL_RDPECAM_CLIENT=ON \
        $(empty)
else
    DEB_CMAKE_EXTRA_FLAGS += \
        -DCHANNEL_URBDRC=OFF \
        -DCHANNEL_URBDRC_CLIENT=OFF \
        $(empty)

    DEB_CMAKE_EXTRA_FLAGS += \
        -DWITH_ALSA=OFF \
        -DWITH_LIBSYSTEMD=OFF \
        -DWITH_WAYLAND=OFF \
        $(empty)
endif

# Ubuntu can't have ffmpeg in main
# Ubuntu doesn't yet have cjson or pkcs11-helper
# or uriparser in main
ifeq ($(shell dpkg-vendor --is Ubuntu && echo yes),yes)
    DEB_CMAKE_EXTRA_FLAGS += \
        -DWITH_FFMPEG=OFF \
        -DWITH_GSM=OFF \
        -DWITH_CAIRO=ON \
        -DWITH_PKCS11=OFF \
        -DWITH_SWSCALE=OFF \
        -DWITH_URIPARSER=OFF \
        -DCHANNEL_RDPECAM_CLIENT=OFF \
        $(empty)
else
    DEB_CMAKE_EXTRA_FLAGS += \
        -DWITH_GSM=ON \
        -DWITH_SWSCALE=ON \
        -DWITH_DSP_FFMPEG=ON \
        -DSWScale_INCLUDE_DIRS=/usr/include/$(DEB_HOST_MULTIARCH) \
        -DWITH_CAIRO=OFF \
        $(empty)
endif

%:
	dh $@

override_dh_auto_configure-indep:
override_dh_auto_build-indep:
override_dh_auto_install-indep:

override_dh_auto_configure-arch:
	dh_auto_configure -- $(DEB_CMAKE_EXTRA_FLAGS)

# all packages depends on exact same version of libwinpr3-3: link docs to it
# only do this for arch packages, as arch<=>indep dir_to_symlink is forbidden
doc-pkg := libwinpr3-3
override_dh_installdocs-arch:
	dh_installdocs -p ${doc-pkg}
	for p in $$(dh_listpackages -a | grep -v '^${doc-pkg}$$'); do \
	    mkdir -p debian/$$p/usr/share/doc; \
	    ln -s ${doc-pkg} debian/$$p/usr/share/doc/$$p; \
	    echo "dir_to_symlink /usr/share/doc/$$p ${doc-pkg} 3.17.1+dfsg-1~" >\
		debian/$$p.maintscript; \
	done
